# Copyright (C) 2022 RozK
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from engine import create_texture, select_texture, unselect_texture, destroy_texture

class Texture:
    __slots__ = '_texture'

    def __init__(self, format, width, height, nlevels, flags, pixels):
        self._texture = create_texture(format, width, height, nlevels, flags, pixels)

    def __del__(self):
        destroy_texture(self._texture)

    def select(self, slot):
        select_texture(slot, self._texture)

    def unselect(self, slot):
        unselect_texture(slot, self._texture)
